/* $Id: point.h,v 1.5 2005/12/26 22:29:22 jonathan Exp $
 * Jonathan Ledlie, Harvard University.
 * Copyright 2005.  All rights reserved.
 */

#ifndef POINT_H
#define POINT_H

class Point {
  friend ostream& operator << (ostream& os, Point *p);
public:
  double *v;
  double height;
  int stamp;

  Point ();
  Point (int stamp);
  Point (const Point *v);
  Point (const double *vec, double h);
  ~Point ();
  void clear ();
  void scale (double s);
  double length ();
  void bump ();
  void add (const Point *adjustment);
  bool isInInitialState ();
  void checkHeight ();
  double getAbsoluteDistance (const Point *b);
  double getEuclideanDistance (const Point *b);
  double getPlanarDistance (const Point *b);
  void assign (const Point *vec);
  Point* getDirection (const Point *p);
  bool operator<(const Point *rhs) const;
  bool operator<(int rhs);
  static Point* getRandomUnitVector ();
  void print ();
};

#endif
